﻿Imports System.Net
Imports System.Net.Http
Imports System.Windows.Forms
Imports System.Net.Http.Headers
Imports System.Runtime.InteropServices

Namespace VBParadise.Client
    Public Class RestClient

        Private objThisUA As HttpClient

        Private strThisBasePath As String


        Public Sub New(ByVal pobjBaseUrl As String, ByVal pobjBasePath As String)

            strThisBasePath = If((pobjBasePath Is Nothing), "", pobjBasePath)

            objThisUA = New HttpClient()

            objThisUA.BaseAddress = New Uri(pobjBaseUrl & strThisBasePath.Substring(If(strThisBasePath.StartsWith("/"), 1, 0)))

            objThisUA.DefaultRequestHeaders.Accept.Add(New MediaTypeWithQualityHeaderValue("application/json"))

        End Sub


        Public Function sendGET(Of T)(ByVal pobjUri As String, <Out> ByRef pobjResponse As HttpResponseMessage) As T

            pobjResponse = Nothing

            Dim objContent As T = Nothing

            pobjResponse = objThisUA.GetAsync(pobjUri).Result


            If pobjResponse.IsSuccessStatusCode Then

                objContent = pobjResponse.Content.ReadAsAsync(Of T)().Result

                Dim objDictContent As Dictionary(Of String, Object) = TryCast(objContent, Dictionary(Of String, Object))

            Else

                Dim objErrors As Dictionary(Of String, Object) = pobjResponse.Content.ReadAsAsync(Of Dictionary(Of String, Object))().Result

                objContent = Nothing

            End If


            Return objContent

        End Function
    End Class
End Namespace